<?php

/**
 * Iverest Ltd. (http://www.iverest.com)
 *
 * CMPIResponse.php
 * Version 1.0 25/04/2014
 * 
 */

class CMPIResponse {
	
	const FIELD_ERRORNO = 'ErrorNo';
	const FIELD_ERRORDESC = 'ErrorDesc';
	
	protected $data = array();
	protected $errors = array();
	
	public function setData($data) {
		$this->data = $data;
		$this->_setErrors();
		return $this;
	}
	
	protected function _setErrors() {
		$this->errors = array();
		if (!isset($this->data[self::FIELD_ERRORNO]) || 
			!isset($this->data[self::FIELD_ERRORDESC])) {
			return;
		}
		$errorMessages = explode(',', $this->data[self::FIELD_ERRORDESC]);
		$errorNumbers = explode(',', $this->data[self::FIELD_ERRORNO]);
		foreach ($errorNumbers as $key => $errorNumber) {
			$this->errors[trim($errorNumber)] = trim($errorMessages[$key]);
		}
	}
	
	public function hasErrors() {
		return (isset($this->data[self::FIELD_ERRORNO]) && 
			!empty($this->data[self::FIELD_ERRORNO]));
	}
	
	public function getErrors() {
		return $this->errors;
	}
	
	public function getField($field, $defaultValue = null) {
		return (isset($this->data[$field]) ? $this->data[$field] : $defaultValue);
	}
	
	public function getFields() {
		return $this->data;
	}
	
}